# React Alegrify UI

[![NPM](https://nodei.co/npm/react-alegrify-ui.png)](https://npmjs.org/package/react-alegrify-ui)

## What is React Alegrify UI?

React Alegrify UI is a React wrapper around [Alegrify UI](https://dejakob.com/alegrify-ui).

As we believe human knowledge should be shared, we made some of our User Interface Elements available 
for everyone who wants to use it.

This repo is a React implementation of the available elements.

## How to use

First, install the dependency with yarn, npm or any alternative:

```bash
yarn add react-alegrify-ui
```

Next, add the CSS file into your project.
Most react projects support CSS imports (e.g. projects that are set up with create-react-app).
In those cases, this should do the trick:

```js
import '../node_modules/alegrify-ui/alegrify-ui.min.css';
```

In any other case manually include the [alegrify-ui.min.css](https://raw.githubusercontent.com/dejakob/alegrify-ui/master/alegrify-ui.min.css) file into your html file:

```html
<link rel="stylesheet" href="<PATH>/alegrify-ui.min.css" />
```

When these steps are fulfilled, you can easily import any component by doing

```js
import { Button } from 'react-alegrify-ui';
```

## Components

* [A (link)](https://dejakob.com/react-alegrify-ui/docs-build/a.html)
* [Avatar](https://dejakob.com/react-alegrify-ui/docs-build/avatar.html)
* [Button](https://dejakob.com/react-alegrify-ui/docs-build/button.html)
* [Card](https://dejakob.com/react-alegrify-ui/docs-build/card.html)
* [Checkbox](https://dejakob.com/react-alegrify-ui/docs-build/checkbox.html)
* [Dialog](https://dejakob.com/react-alegrify-ui/docs-build/dialog.html)
* [Dl](https://dejakob.com/react-alegrify-ui/docs-build/dl.html)
* [Drawer](https://dejakob.com/react-alegrify-ui/docs-build/drawer.html)
* [Dropdown](https://dejakob.com/react-alegrify-ui/docs-build/dropdown.html)
* [Footer](https://dejakob.com/react-alegrify-ui/docs-build/footer.html)
* [Grid](https://dejakob.com/react-alegrify-ui/docs-build/grid.html)
* [Input](https://dejakob.com/react-alegrify-ui/docs-build/input.html)
* [Label](https://dejakob.com/react-alegrify-ui/docs-build/label.html)
* [Notification](https://dejakob.com/react-alegrify-ui/docs-build/notification.html)
* [Radio](https://dejakob.com/react-alegrify-ui/docs-build/radio.html)
* [Range Input](https://dejakob.com/react-alegrify-ui/docs-build/range-input.html)
* [Section](https://dejakob.com/react-alegrify-ui/docs-build/section.html)
* [Stepper](https://dejakob.com/react-alegrify-ui/docs-build/stepper.html)
* [Typography](https://dejakob.com/react-alegrify-ui/docs-build/typography.html)
* [Ul](https://dejakob.com/react-alegrify-ui/docs-build/ul.html)

## Helpers

* [Spacing](https://dejakob.com/react-alegrify-ui/docs-build/spacing.html)
